#!/v/guest/sw/bin/perl -w

###############################################################################
##                                                                           ##
##    Copyright (c) 2010 by Steffen Beyer.                                   ##
##    All rights reserved.                                                   ##
##                                                                           ##
##    This program is free software; you can redistribute it                 ##
##    and/or modify it under the same terms as Perl itself.                  ##
##                                                                           ##
###############################################################################

use strict;

use lib
qw(
    /u/sb/sw/pkg/perl/lib/perl/5.12.0/amd64-freebsd
    /u/sb/sw/pkg/perl/lib/perl/5.12.0
    /u/sb/sw/pkg/perl/lib/perl/site_perl/5.12.0/amd64-freebsd
    /u/sb/sw/pkg/perl/lib/perl/site_perl/5.12.0
);

use Date::Calc qw(:all);
use Storable qw(lock_nstore lock_retrieve);

umask(022);

my $Const = 'const.bin';
my $File  = 'data.bin';
my $Data  = {};
my $Fixed = {};
my $Save  = 0;
my $Today = Date_to_Days(Today());

my $Replace_disabled =
{
    '1' => qq{19:30h - 21:00h: Regularly Recurring Event: Training Session on Monday\n},
    '4' => qq{18:30h - 20:00h: Regularly Recurring Event: Playing Session on Thursday\n}
};

my $Replace =
{
    '1' => qq{Competition training\n19:00 - 21:00\nTrain individual skills and team playing (positions) with a coach.\nPlay a friendly match.\n},
    '3' => qq{Come and Play\n19:30 - 21:00\nPlay friendly matches after a short warm-up.\n}
};

if (-e $Const)
{
    eval { $Fixed = lock_retrieve($Const); };
    if ($@) { $Fixed = {}; }
}

if (-e $File)
{
    eval { $Data = lock_retrieve($File); };
    if ($@) { $Data = {}; }
}

my($key,$dow,$n);

foreach $key (keys %{$Data})
{
    $dow = $key - int(($key-1)/7) * 7;
    if ($key >= $Today and exists $Fixed->{$dow} and defined $Fixed->{$dow} and $Fixed->{$dow} ne '')
    {
        if (exists $Data->{$key} and defined $Data->{$key} and ref($Data->{$key}) eq 'ARRAY' and @{$Data->{$key}})
        {
            $n = 0;
            while ( $n < @{$Data->{$key}} )
            {
                if (exists $Replace->{$dow} and defined $Replace->{$dow} and $Replace->{$dow} ne '')
                {
                    if ($Data->{$key}[$n][0] eq $Fixed->{$dow} and $Fixed->{$dow} ne $Replace->{$dow})
                    {
                        $Data->{$key}[$n][0] = $Replace->{$dow};
                        $Save = 1;
                    }
                    $n++;
                }
                else
                {
                    if ($Data->{$key}[$n][0] eq $Fixed->{$dow})
                    {
                        splice(@{$Data->{$key}},$n,1);
                        $Save = 1;
                    }
                    else { $n++; }
                }
            }
        }
    }
}

if ($Save)
{
    eval { lock_nstore($Data, $File); };
}

eval { lock_nstore($Replace, $Const); };

__END__

